---
title: Delete Test Optimization service settings
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Test Optimization
---

# Delete Test Optimization service settings{% #delete-test-optimization-service-settings %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                                                      |
| ----------------- | --------------------------------------------------------------------------------- |
| ap1.datadoghq.com | DELETE https://api.ap1.datadoghq.com/api/v2/ci/test-optimization/settings/service |
| ap2.datadoghq.com | DELETE https://api.ap2.datadoghq.com/api/v2/ci/test-optimization/settings/service |
| app.datadoghq.eu  | DELETE https://api.datadoghq.eu/api/v2/ci/test-optimization/settings/service      |
| app.ddog-gov.com  | DELETE https://api.ddog-gov.com/api/v2/ci/test-optimization/settings/service      |
| us2.ddog-gov.com  | DELETE https://api.us2.ddog-gov.com/api/v2/ci/test-optimization/settings/service  |
| app.datadoghq.com | DELETE https://api.datadoghq.com/api/v2/ci/test-optimization/settings/service     |
| us3.datadoghq.com | DELETE https://api.us3.datadoghq.com/api/v2/ci/test-optimization/settings/service |
| us5.datadoghq.com | DELETE https://api.us5.datadoghq.com/api/v2/ci/test-optimization/settings/service |

### Overview

Delete Test Optimization settings for a specific service identified by repository, service name, and environment. This endpoint requires the `test_optimization_settings_write` permission.

OAuth apps require the `test_optimization_settings_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#test-optimization) to access this endpoint.



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                           | Type   | Description                                                                                                                                                                                               |
| ------------ | ------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]          | object | Data object for delete service settings request.                                                                                                                                                          |
| data         | attributes [*required*]    | object | Attributes for deleting Test Optimization service settings.                                                                                                                                               |
| attributes   | env                             | string | The environment name. If omitted, defaults to `none`.                                                                                                                                                     |
| attributes   | repository_id [*required*] | string | The repository identifier.                                                                                                                                                                                |
| attributes   | service_name [*required*]  | string | The service name.                                                                                                                                                                                         |
| data         | type [*required*]          | enum   | JSON:API type for delete service settings request. The value must always be `test_optimization_delete_service_settings_request`. Allowed enum values: `test_optimization_delete_service_settings_request` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "env": "prod",
      "repository_id": "github.com/datadog/shopist",
      "service_name": "shopist"
    },
    "type": "test_optimization_delete_service_settings_request"
  }
}
```

{% /tab %}

### Response

{% tab title="204" %}
No Content
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Not Authorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X DELETE "https://api.datadoghq.com/api/v2/ci/test-optimization/settings/service" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "env": "prod",
      "repository_id": "github.com/datadog/test-service",
      "service_name": "test-service"
    },
    "type": "test_optimization_delete_service_settings_request"
  }
}
EOF 
                
##### 

```python
"""
Delete Test Optimization service settings returns "No Content" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.test_optimization_api import TestOptimizationApi
from datadog_api_client.v2.model.test_optimization_delete_service_settings_request import (
    TestOptimizationDeleteServiceSettingsRequest,
)
from datadog_api_client.v2.model.test_optimization_delete_service_settings_request_attributes import (
    TestOptimizationDeleteServiceSettingsRequestAttributes,
)
from datadog_api_client.v2.model.test_optimization_delete_service_settings_request_data import (
    TestOptimizationDeleteServiceSettingsRequestData,
)
from datadog_api_client.v2.model.test_optimization_delete_service_settings_request_data_type import (
    TestOptimizationDeleteServiceSettingsRequestDataType,
)

body = TestOptimizationDeleteServiceSettingsRequest(
    data=TestOptimizationDeleteServiceSettingsRequestData(
        attributes=TestOptimizationDeleteServiceSettingsRequestAttributes(
            env="prod",
            repository_id="github.com/datadog/shopist",
            service_name="shopist",
        ),
        type=TestOptimizationDeleteServiceSettingsRequestDataType.TEST_OPTIMIZATION_DELETE_SERVICE_SETTINGS_REQUEST,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = TestOptimizationApi(api_client)
    api_instance.delete_test_optimization_service_settings(body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Delete Test Optimization service settings returns "No Content" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::TestOptimizationAPI.new

body = DatadogAPIClient::V2::TestOptimizationDeleteServiceSettingsRequest.new({
  data: DatadogAPIClient::V2::TestOptimizationDeleteServiceSettingsRequestData.new({
    attributes: DatadogAPIClient::V2::TestOptimizationDeleteServiceSettingsRequestAttributes.new({
      env: "prod",
      repository_id: "github.com/datadog/shopist",
      service_name: "shopist",
    }),
    type: DatadogAPIClient::V2::TestOptimizationDeleteServiceSettingsRequestDataType::TEST_OPTIMIZATION_DELETE_SERVICE_SETTINGS_REQUEST,
  }),
})
api_instance.delete_test_optimization_service_settings(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Delete Test Optimization service settings returns "No Content" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.TestOptimizationDeleteServiceSettingsRequest{
		Data: datadogV2.TestOptimizationDeleteServiceSettingsRequestData{
			Attributes: datadogV2.TestOptimizationDeleteServiceSettingsRequestAttributes{
				Env:          datadog.PtrString("prod"),
				RepositoryId: "github.com/datadog/shopist",
				ServiceName:  "shopist",
			},
			Type: datadogV2.TESTOPTIMIZATIONDELETESERVICESETTINGSREQUESTDATATYPE_TEST_OPTIMIZATION_DELETE_SERVICE_SETTINGS_REQUEST,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewTestOptimizationApi(apiClient)
	r, err := api.DeleteTestOptimizationServiceSettings(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `TestOptimizationApi.DeleteTestOptimizationServiceSettings`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Delete Test Optimization service settings returns "No Content" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.TestOptimizationApi;
import com.datadog.api.client.v2.model.TestOptimizationDeleteServiceSettingsRequest;
import com.datadog.api.client.v2.model.TestOptimizationDeleteServiceSettingsRequestAttributes;
import com.datadog.api.client.v2.model.TestOptimizationDeleteServiceSettingsRequestData;
import com.datadog.api.client.v2.model.TestOptimizationDeleteServiceSettingsRequestDataType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    TestOptimizationApi apiInstance = new TestOptimizationApi(defaultClient);

    TestOptimizationDeleteServiceSettingsRequest body =
        new TestOptimizationDeleteServiceSettingsRequest()
            .data(
                new TestOptimizationDeleteServiceSettingsRequestData()
                    .attributes(
                        new TestOptimizationDeleteServiceSettingsRequestAttributes()
                            .env("prod")
                            .repositoryId("github.com/datadog/shopist")
                            .serviceName("shopist"))
                    .type(
                        TestOptimizationDeleteServiceSettingsRequestDataType
                            .TEST_OPTIMIZATION_DELETE_SERVICE_SETTINGS_REQUEST));

    try {
      apiInstance.deleteTestOptimizationServiceSettings(body);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling TestOptimizationApi#deleteTestOptimizationServiceSettings");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Delete Test Optimization service settings returns "No Content" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_test_optimization::TestOptimizationAPI;
use datadog_api_client::datadogV2::model::TestOptimizationDeleteServiceSettingsRequest;
use datadog_api_client::datadogV2::model::TestOptimizationDeleteServiceSettingsRequestAttributes;
use datadog_api_client::datadogV2::model::TestOptimizationDeleteServiceSettingsRequestData;
use datadog_api_client::datadogV2::model::TestOptimizationDeleteServiceSettingsRequestDataType;

#[tokio::main]
async fn main() {
    let body =
        TestOptimizationDeleteServiceSettingsRequest::new(
            TestOptimizationDeleteServiceSettingsRequestData::new(
                TestOptimizationDeleteServiceSettingsRequestAttributes::new(
                    "github.com/datadog/shopist".to_string(),
                    "shopist".to_string(),
                ).env("prod".to_string()),
                TestOptimizationDeleteServiceSettingsRequestDataType
                ::TEST_OPTIMIZATION_DELETE_SERVICE_SETTINGS_REQUEST,
            ),
        );
    let configuration = datadog::Configuration::new();
    let api = TestOptimizationAPI::with_config(configuration);
    let resp = api.delete_test_optimization_service_settings(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Delete Test Optimization service settings returns "No Content" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.TestOptimizationApi(configuration);

const params: v2.TestOptimizationApiDeleteTestOptimizationServiceSettingsRequest =
  {
    body: {
      data: {
        attributes: {
          env: "prod",
          repositoryId: "github.com/datadog/shopist",
          serviceName: "shopist",
        },
        type: "test_optimization_delete_service_settings_request",
      },
    },
  };

apiInstance
  .deleteTestOptimizationServiceSettings(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
